## sitplus 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#
# Project information
#

project(sitplus)

set(APP_NAME "sitplus")
set(SITPLUS_MAJOR_VERSION 1)
set(SITPLUS_MINOR_VERSION 0)
set(SITPLUS_REVISION_VERSION 1)
set(SITPLUS_VERSION "${SITPLUS_MAJOR_VERSION}.${SITPLUS_MINOR_VERSION}.${SITPLUS_REVISION_VERSION}")

# if this is set to ON, then all libraries are built as shared libraries by default.
# currently used to tell wxWidgets the libs to link against to
SET(BUILD_SHARED_LIBS ON)
#set(WHOLE_PROGRAM_OPTIMIZATION OFF CACHE BOOL "Flags for whole program optimization.")

SET(CMAKE_VERBOSE_MAKEFILE false)

if(WIN32)
	set(_WIN32_WINNT "0x0500")
endif(WIN32)

#
# Set default build mode
#

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

#
# Directories
#

set (BINDIR "bin")
set (LIBDIR "lib")
if (WIN32)
	set (LOCALEDIR "${BINDIR}/locale")
	set (DATADIR "${BINDIR}")
	set (DOCDIR "${BINDIR}/doc")
	set (PLUGINDIR "${BINDIR}")
	set (LIBRUNTIMEDIR "${BINDIR}")
else(WIN32)
	set (LOCALEDIR "share/locale")
	set (DATADIR "share/${APP_NAME}")
	set (DOCDIR "${DATADIR}/doc")
	set (PLUGINDIR "lib")
	set (LIBRUNTIMEDIR "lib")
endif(WIN32)


#
# PATHS
# 
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/3rdparty)
# For the add_library & add_executable commands
set (CUSTOM_INCLUDE_PATH "${CMAKE_SOURCE_DIR}/include")
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${BINDIR})
set (LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})

#set (RUNTIME_OUTPUT_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})

#
# Additional compiler flags. Needed for Linux 64 bit 
#
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
add_definitions(-fPIC)
ENDIF(CMAKE_SYSTEM_NAME MATCHES "Linux")

#
# Testing
#

#ENABLE_TESTING()

#####################################################################
# MACROS
#####################################################################

# - Copies a file to the MSVC build directories
#
# Visual Studio users expect to be able to click "Run" and have the application
# run correctly from the build directory. This macro provides the ability to 
# install files to the build directory so that his behaviour works as expected.
#
# This module defines the following macros:
# install_to_msvc_build_directory
macro(install_to_msvc_build_directory INSTALL_PREFIX_DIR INSTALL_FILE)
    #foreach(_MSVC_BUILD_TYPE ${CMAKE_CONFIGURATION_TYPES})
	foreach(_MSVC_BUILD_TYPE ${CMAKE_BUILD_TYPE})	
        set(_OUTPUT_DIRECTORY "${INSTALL_PREFIX_DIR}/${_MSVC_BUILD_TYPE}")
        if (${ARGC} STRGREATER 2)
            set(_INSTALL_SUFFIX_DIR ${ARGV2})
            set(_OUTPUT_DIRECTORY "${_OUTPUT_DIRECTORY}/${_INSTALL_SUFFIX_DIR}")
        endif (${ARGC} STRGREATER 2)
        
        get_filename_component(_INSTALL_FILENAME "${INSTALL_FILE}" NAME)
        configure_file(
            ${INSTALL_FILE}
            ${_OUTPUT_DIRECTORY}/${_INSTALL_FILENAME}
            COPYONLY
        )
    endforeach(_MSVC_BUILD_TYPE ${CMAKE_CONFIGURATION_TYPES})
endmacro(install_to_msvc_build_directory)

#####################################################################
# Required libraries
#####################################################################

#
# Boost
#

IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(Boost_USE_STATIC_LIBS OFF)
	set(Boost_USE_STATIC_RUNTIME    OFF)
else ()
	set(Boost_USE_STATIC_LIBS ON)
endif()
set(Boost_USE_MULTITHREAD ON)
#set(Boost_USE_STATIC_RUNTIME    OFF)

find_package(Boost COMPONENTS thread REQUIRED)
find_package(Boost COMPONENTS program_options REQUIRED)
message(STATUS "Boost_INCLUDE_DIR    : ${Boost_INCLUDE_DIR}")
message(STATUS "Boost_THREAD_LIBRARY : ${Boost_THREAD_LIBRARY}")
message(STATUS "Boost_PROGRAM_OPTIONS_LIBRARY : ${Boost_PROGRAM_OPTIONS_LIBRARY}")

# Boost version 1.39 or greater required 
# Lower versions fail to compile with g++ 4.4
IF ((${Boost_MAJOR_VERSION} LESS 1) OR 
	(${Boost_MAJOR_VERSION} EQUAL 1) AND (${Boost_MINOR_VERSION} LESS 39))
	MESSAGE (FATAL_ERROR "Boost version less than 1.39")
ENDIF()
include_directories ( ${Boost_INCLUDE_DIRS} )
link_directories ( ${Boost_LIBRARY_DIRS} )

#
# POCO
#

find_package(POCO)
if(WIN32)
	find_file (POCO_FOUNDATION_RUNTIMED bin/PocoFoundationd.dll HINTS $ENV{POCO_ROOT})
#	find_file (POCO_XML_RUNTIMED bin/PocoXMLd.dll HINTS $ENV{POCO_ROOT})
	find_file (POCO_FOUNDATION_RUNTIME bin/PocoFoundation.dll HINTS $ENV{POCO_ROOT})
#	find_file (POCO_XML_RUNTIME bin/PocoXML.dll HINTS $ENV{POCO_ROOT})
	if (MSVC)
		install_to_msvc_build_directory("${EXECUTABLE_OUTPUT_PATH}" "${POCO_FOUNDATION_RUNTIMED}")
#		install_to_msvc_build_directory("${EXECUTABLE_OUTPUT_PATH}" "${POCO_XML_RUNTIMED}")
	endif(MSVC)
	
#	install(FILES ${POCO_FOUNDATION_RUNTIMED} ${POCO_XML_RUNTIMED} DESTINATION "${BINDIR}" CONFIGURATIONS Debug)
#	install(FILES ${POCO_FOUNDATION_RUNTIME} ${POCO_XML_RUNTIME} DESTINATION "${BINDIR}" CONFIGURATIONS Release RelWithDebInfo)
	
	install(FILES ${POCO_FOUNDATION_RUNTIMED} DESTINATION "${BINDIR}" CONFIGURATIONS Debug)
	install(FILES ${POCO_FOUNDATION_RUNTIME} DESTINATION "${BINDIR}" CONFIGURATIONS Release RelWithDebInfo)
endif(WIN32)

#
# wxWidgets
#

option(ENABLE_WXWIDGETS "Enable wxWidgets support" 1)

if (ENABLE_WXWIDGETS)
	if(WIN32)
		set(wxWidgets_CONFIGURATION "mswu")
	else(WIN32)
		if (CMAKE_BUILD_TYPE MATCHES Debug)
			set(wxWidgets_USE_DEBUG ON)
		else()
			set(wxWidgets_USE_DEBUG OFF)
		endif()
		set(wxWidgets_USE_UNICODE TRUE)
	endif(WIN32)
	message (STATUS "wxWidgets_USE_DEBUG : ${wxWidgets_USE_DEBUG}")

	find_package(wxWidgets COMPONENTS core base REQUIRED)
	include(${wxWidgets_USE_FILE})
	message(STATUS "wxWidgets_LIBRARIES : ${wxWidgets_LIBRARIES}")
	message(STATUS "wxWidgets_DEFINITIONS : ${wxWidgets_DEFINITIONS}")
	message(STATUS "wxWidgets_DEFINITIONS_DEBUG : ${wxWidgets_DEFINITIONS_DEBUG}")
	message(STATUS "wxWidgets_ROOT_DIR	: ${wxWidgets_ROOT_DIR}")

	# Make sure wxWidgets are available for debugging
	if (WIN32)
		if (MSVC)
			install_to_msvc_build_directory( "${EXECUTABLE_OUTPUT_PATH}" "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxbase28ud_vc_custom.dll")
			install_to_msvc_build_directory( "${EXECUTABLE_OUTPUT_PATH}" "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxmsw28ud_core_vc_custom.dll")
		endif(MSVC)
	
		install(FILES "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxbase28ud_vc_custom.dll" "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxmsw28ud_core_vc_custom.dll" DESTINATION "${BINDIR}" CONFIGURATIONS Debug)
		install(FILES "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxbase28u_vc_custom.dll" "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxmsw28u_core_vc_custom.dll" DESTINATION "${BINDIR}" CONFIGURATIONS Release RelWithDebInfo)
	endif(WIN32)
endif (ENABLE_WXWIDGETS)

#
# i18n
#

option(ENABLE_NLS "Enable translations support and building" ON)
if (ENABLE_NLS)
	if (WIN32)
		option(ENABLE_POT_UPDATE_TARGET "Enables the tools to update the pot files." OFF)
	else(WIN32)
		option(ENABLE_POT_UPDATE_TARGET "Enables the tools to update the pot files." ON)
	endif(WIN32)

	find_package(Gettext REQUIRED)
	find_package(Libintl REQUIRED)

	if(ENABLE_POT_UPDATE_TARGET)
		find_package(TranslationTools REQUIRED)
	endif(ENABLE_POT_UPDATE_TARGET)
	
	# get languages
	file(READ po/LINGUAS LINGUAS)
	string(REPLACE "\n" "" LINGUAS ${LINGUAS})
	separate_arguments(LINGUAS)
	
	INCLUDE_DIRECTORIES(${LIBINTL_INCLUDE_DIR})
	add_subdirectory(po)
	
	if(WIN32)
		install(FILES "${LIBINTL_ROOT_PATH}/bin/libintl3.dll"  "${LIBINTL_ROOT_PATH}/bin/libiconv2.dll" DESTINATION "${BINDIR}")
	endif(WIN32)	
endif (ENABLE_NLS)

#####################################################################
# configuration file
#####################################################################
configure_file ("${PROJECT_SOURCE_DIR}/include/config.h.in"
                "${PROJECT_BINARY_DIR}/include/config.h" )
configure_file ("${PROJECT_SOURCE_DIR}/include/version.h.in"
                "${PROJECT_BINARY_DIR}/include/version.h" )
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include/)

#####################################################################
# Compiler flags
#####################################################################
#
#  Maximum level of warnings enabled
# 

set(EXTRA_C_FLAGS "")
set(EXTRA_C_FLAGS_RELEASE "")
set(EXTRA_C_FLAGS_DEBUG "")
set(EXTRA_EXE_LINKER_FLAGS "")
set(EXTRA_EXE_LINKER_FLAGS_RELEASE "")
set(EXTRA_EXE_LINKER_FLAGS_DEBUG "")

if(MSVC)
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /D _CRT_SECURE_NO_DEPRECATE /D _CRT_NONSTDC_NO_DEPRECATE /D _SCL_SECURE_NO_WARNINGS")
    # 64-bit portability warnings, in MSVC8
    if(MSVC80)
        set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /Wp64")
    endif()
    if(MSVC90)
	set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /D _BIND_TO_CURRENT_CRT_VERSION=1 /D _BIND_TO_CURRENT_VCLIBS_VERSION=1")
    endif()

    set(EXTRA_EXE_LINKER_FLAGS_RELEASE "${EXTRA_EXE_LINKER_FLAGS_RELEASE} /debug")

    # Whole program optimization
    if(WHOLE_PROGRAM_OPTIMIZATION AND MSVC_VERSION GREATER 1300)
        set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} /GL")
        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
        set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} /LTCG")
    endif()   
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    # High level of warnings.
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wall")

    # The -Wno-long-long is required in 64bit systems when including sytem headers.
    if(${CMAKE_SYSTEM_PROCESSOR} MATCHES x86_64*)
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-long-long")
    endif()
    if(${CMAKE_SYSTEM_PROCESSOR} MATCHES amd64*)
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-long-long")
    endif()

    # Whole program optimization
    if(WHOLE_PROGRAM_OPTIMIZATION)
        set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -fwhole-program --combine")
    endif()

    # Other optimizations
    if(USE_OMIT_FRAME_POINTER)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -fomit-frame-pointer")
    endif()
    if(USE_O2)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -O2")
    endif()
    if(USE_O3)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -O3")
    endif()
    if(USE_FAST_MATH)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -ffast-math")
    endif()
    if(USE_POWERPC)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -mcpu=G3 -mtune=G5")
    endif()
    if(USE_MMX)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -mmmx")
    endif()
    # SSE should be disabled under MingW because it generates compiler errors
    if(USE_SSE)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -msse")
    endif()
    # SSE2 should be disabled under MingW because it generates compiler errors
    if(USE_SSE2)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -msse2")
    endif()
    # SSE3 should be disabled under MingW because it generates compiler errors
    if(USE_SSE3 AND NOT MINGW)
       set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -msse3")
    endif()

    set(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} -DNDEBUG")
    set(EXTRA_C_FLAGS_DEBUG "${EXTRA_C_FLAGS_DEBUG} -O0 -DDEBUG -D_DEBUG")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_FLAGS}")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${EXTRA_C_FLAGS_RELEASE}")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${EXTRA_C_FLAGS_RELEASE}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${EXTRA_C_FLAGS_DEBUG}")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${EXTRA_C_FLAGS_DEBUG}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${EXTRA_EXE_LINKER_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} ${EXTRA_EXE_LINKER_FLAGS_RELEASE}")
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} ${EXTRA_EXE_LINKER_FLAGS_DEBUG}")

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
add_subdirectory(spcore)
add_subdirectory(mod_sdl)
add_subdirectory(testcommon)
add_subdirectory(creavision)
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
add_subdirectory(libwebcam)
ENDIF(CMAKE_SYSTEM_NAME MATCHES "Linux")
add_subdirectory(mod_camera)
add_subdirectory(mod_collage)
add_subdirectory(mod_wiimotes)
add_subdirectory(mod_midi)
add_subdirectory(widgets_base)
add_subdirectory(sitplus)
add_subdirectory(mod_vision)
add_subdirectory(sphost)
add_subdirectory(mod_widgets)
add_subdirectory(mod_score_player)
add_subdirectory(mod_puredata)
add_subdirectory(mod_io)

=== 3rdparty/wiiuse/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(wiiuselib)

#set (CMAKE_VERBOSE_MAKEFILE ON)

#
# Set default build mode
#

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

#
# Compilation flags
#

#IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
#	ADD_DEFINITIONS (-DWITH_WIIUSE_DEBUG)
#ENDIF()

IF (CMAKE_COMPILER_IS_GNUCC)
	ADD_DEFINITIONS (-Wall)
ENDIF()

SET (WIIUSE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include")
INCLUDE_DIRECTORIES(${WIIUSE_INCLUDE_DIRECTORIES})

IF (NOT EXECUTABLE_OUTPUT_PATH)
	set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
ENDIF()

IF (NOT LIBRARY_OUTPUT_PATH)
	set (LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
ENDIF()

SET(WIIUSE_BUILD_EXAMPLES OFF CACHE BOOL "Build examples")

add_subdirectory(src)

IF (WIIUSE_BUILD_EXAMPLES)
	add_subdirectory(example)
	add_subdirectory(example-sdl)
ENDIF()

=== src/creavision/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(creavision)

set(creavision_SRCS
	crvcamera.h
	crvcamera.cpp
	crvcamera_enum.h
	crvcamera_enum.cpp	
	crvcolor.cpp
	crvcolor.h
	crvgeomtry.cpp
	crvgeomtry.h
	crvhistogram.cpp
	crvhistogram.h
	crvimage.cpp
	crvimage.h
	crvmisc.cpp
	crvmisc.h
	crvnormroi.cpp
	crvnormroi.h
	crvskindetection.cpp
	crvskindetection.h
)

IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
FIND_PACKAGE( GLIB2 REQUIRED )
INCLUDE_DIRECTORIES (${GLIB2_INCLUDE_DIRS})
INCLUDE_DIRECTORIES (../libwebcam)
set(creavision_SRCS ${creavision_SRCS}
	crvcamera_v4l2.cpp
	crvcamera_v4l2.h
	colorspaces.cpp
	colorspaces.h
	pwc-ioctl.h
	defs.h
)
ELSEIF(WIN32)
set(creavision_SRCS ${creavision_SRCS}
	crvcamera_wdm.cpp
	crvcamera_wdm.h
	videoInput.cpp
	videoInput.h
)
ELSE(CMAKE_SYSTEM_NAME MATCHES "Linux")
set(creavision_SRCS ${creavision_SRCS}
	crvcamera_cv.cpp
	crvcamera_cv.h
)
ENDIF(CMAKE_SYSTEM_NAME MATCHES "Linux")

if(UNIX)
	# For UNIX platforms we assume OpenCV is under /usr which 
	# would not be always true
	set (OpenCV_DIR "/usr")
endif(UNIX)

FIND_PACKAGE( OpenCV REQUIRED )

message(STATUS "OpenCV_FOUND. ${OpenCV_FOUND}")
message(STATUS "OpenCV_LIBS. ${OpenCV_LIBS}")
message(STATUS "OpenCV_INCLUDE_DIR. ${OpenCV_INCLUDE_DIR}")

if(WIN32)
	install (FILES 
		"${OpenCV_DIR}/bin/opencv_core220.dll"
		"${OpenCV_DIR}/bin/opencv_highgui220.dll"
		"${OpenCV_DIR}/bin/opencv_imgproc220.dll"
		"${OpenCV_DIR}/bin/opencv_video220.dll"
		DESTINATION ${LIBRUNTIMEDIR}
	)
endif(WIN32)

add_library (creavision STATIC ${creavision_SRCS})
TARGET_LINK_LIBRARIES(creavision ${OpenCV_LIBS} )

IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
	TARGET_LINK_LIBRARIES(creavision libwebcam)
ELSEIF(WIN32)
	TARGET_LINK_LIBRARIES(creavision ole32.lib strmiids.lib uuid.lib dxguid.lib)
ENDIF(CMAKE_SYSTEM_NAME MATCHES "Linux")

=== src/mod_camera/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(mod_camera)

set(mod_camera_SRCS
	${CUSTOM_INCLUDE_PATH}/mod_camera/iplimagetype.h
	${CUSTOM_INCLUDE_PATH}/mod_camera/roitype.h
	roitype.cpp
	mod_camera.cpp
	mod_camera.h
	wcameraconfiguration.cpp
	wcameraconfiguration.h
	wcamerapanel.cpp
	wcamerapanel.h
	wxroicontrol.h
	wxroicontrol.cpp
)

# Base library
FIND_PACKAGE( OpenCV REQUIRED )
INCLUDE_DIRECTORIES (${OpenCV_INCLUDE_DIR})
INCLUDE_DIRECTORIES (..)

add_library (mod_camera SHARED ${mod_camera_SRCS})
target_link_libraries(mod_camera creavision)
target_link_libraries(mod_camera spcore)
target_link_libraries(mod_camera ${Boost_THREAD_LIBRARY})
target_link_libraries(mod_camera ${Boost_PROGRAM_OPTIONS_LIBRARY})
target_link_libraries(mod_camera ${wxWidgets_LIBRARIES})

ADD_SUBDIRECTORY(tests)

INSTALL (TARGETS mod_camera RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})

=== src/mod_collage/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(mod_collage)

find_package(POCO)
find_package ( SDL REQUIRED )
find_package ( SDL_image REQUIRED )
find_package ( SDL_gfx REQUIRED )

set(mod_collage_SRCS
	mod_collage.cpp
)

set (mod_collage_gui_SRCS
	config_gui.h
	config_gui.cpp
)

include_directories (${SDL_INCLUDE_DIR})
include_directories (${SDLIMAGE_INCLUDE_DIR})
include_directories (${SDLGFX_INCLUDE_DIR})

include_directories (${POCO_INCLUDE_DIR})
include_directories (${POCO_XML_INCLUDE_DIR})

# Base library
add_library (mod_collage SHARED ${mod_collage_SRCS})
target_link_libraries(mod_collage spcore)
target_link_libraries(mod_collage mod_XMLImplementation)
target_link_libraries(mod_collage mod_Pictures)
target_link_libraries(mod_collage mod_Kernel)
target_link_libraries(mod_collage mod_collage_gui)

target_link_libraries(mod_collage ${SDL_LIBRARY})
target_link_libraries(mod_collage ${SDLIMAGE_LIBRARY})
target_link_libraries(mod_collage ${SDLGFX_LIBRARY})

target_link_libraries(mod_collage ${POCO_XML_LIBRARY})


# Base gui library
add_library (mod_collage_gui STATIC ${mod_collage_gui_SRCS})
target_link_libraries(mod_collage_gui spcore)
target_link_libraries(mod_collage_gui ${wxWidgets_LIBRARIES})

add_subdirectory(tests)
add_subdirectory(XMLImplementation)
add_subdirectory(Pictures)
add_subdirectory(Kernel)

INSTALL (TARGETS mod_collage RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})
IF (WIN32)
	FIND_PATH (SDL_image_RUNTIME_LIBS_DIR SDL_image.dll
		HINTS
		$ENV{SDLIMAGEDIR}
		PATH_SUFFIXES lib64 lib
		PATHS)
	FILE (GLOB SDL_image_RUNTIME_LIBS ${SDL_image_RUNTIME_LIBS_DIR}/*.dll)
	
	INSTALL (PROGRAMS ${SDL_image_RUNTIME_LIBS} DESTINATION ${LIBRUNTIMEDIR})
	
	FIND_PATH (SDL_gfx_RUNTIME_LIBS_DIR SDL_gfx.dll
		HINTS
		$ENV{SDLGFXDIR}
		PATH_SUFFIXES lib64 lib
		PATHS)
	FILE (GLOB SDL_gfx_RUNTIME_LIBS ${SDL_gfx_RUNTIME_LIBS_DIR}/*.dll)
	
	INSTALL (PROGRAMS ${SDL_gfx_RUNTIME_LIBS} DESTINATION ${LIBRUNTIMEDIR})
ENDIF (WIN32)

if(WIN32)
	find_file (POCO_XML_RUNTIMED bin/PocoXMLd.dll HINTS $ENV{POCO_ROOT})
	find_file (POCO_XML_RUNTIME bin/PocoXML.dll HINTS $ENV{POCO_ROOT})
	if (MSVC)
		install_to_msvc_build_directory("${EXECUTABLE_OUTPUT_PATH}" "${POCO_XML_RUNTIMED}")
	endif(MSVC)
	
	install(FILES ${POCO_XML_RUNTIMED} DESTINATION "${BINDIR}" CONFIGURATIONS Debug)
	install(FILES ${POCO_XML_RUNTIME} DESTINATION "${BINDIR}" CONFIGURATIONS Release RelWithDebInfo)
endif(WIN32)

=== src/mod_io/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(mod_io)

set(mod_io_SRCS
	mod_io.cpp
	filebrowser.h
	filebrowser.cpp
	textfiledump.h
	textfiledump.cpp
)

find_package(Boost COMPONENTS filesystem REQUIRED)
add_library (mod_io SHARED ${mod_io_SRCS})

target_link_libraries(mod_io ${Boost_FILESYSTEM_LIBRARY})
target_link_libraries(mod_io spcore)
if (ENABLE_NLS)
	target_link_libraries(mod_io ${LIBINTL_LIBRARIES})
endif(ENABLE_NLS)

INSTALL (TARGETS mod_io RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})

=== src/mod_midi/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(mod_midi)

find_package ( PortMidi REQUIRED )
if (MSVC)	
	find_file (PortMidi_RUNTIME_REL portmidi.dll HINTS $ENV{PORTMIDIDIR}/lib $ENV{PORTMIDIDIR}/bin)
	find_file (PortMidi_RUNTIME_DBG portmidid.dll HINTS $ENV{PORTMIDIDIR}/lib $ENV{PORTMIDIDIR}/bin)
		
	install_to_msvc_build_directory("${EXECUTABLE_OUTPUT_PATH}" "${PortMidi_RUNTIME_REL}")
	install_to_msvc_build_directory("${EXECUTABLE_OUTPUT_PATH}" "${PortMidi_RUNTIME_DBG}")
endif(MSVC)

set(mod_midi_SRCS
	${CUSTOM_INCLUDE_PATH}/mod_midi/midi_types.h
	mod_midi.cpp
	midiconfiggui.h
	midiconfiggui.cpp
)

include_directories (${PortMidi_INCLUDE_DIRS})
add_library (mod_midi SHARED ${mod_midi_SRCS})
target_link_libraries(mod_midi spcore)
target_link_libraries(mod_midi ${PortMidi_LIBRARIES})
target_link_libraries(mod_midi ${wxWidgets_LIBRARIES})

ADD_SUBDIRECTORY(tests)

INSTALL (TARGETS mod_midi RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})

if(WIN32)
	install(FILES ${PortMidi_RUNTIME_DBG} DESTINATION "${LIBRUNTIMEDIR}" CONFIGURATIONS Debug)
	install(FILES ${PortMidi_RUNTIME_REL} DESTINATION "${LIBRUNTIMEDIR}" CONFIGURATIONS Release RelWithDebInfo)
endif(WIN32)

=== src/mod_puredata/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(mod_puredata)

ADD_SUBDIRECTORY(oscpack)
INCLUDE_DIRECTORIES (oscpack)

set(mod_puredata_SRCS
	puredatawrapper.h
	puredatawrapper.cpp
	puredataconfig.h
	puredataconfig.cpp
	vumeter.h
	vumeter.cpp
	valuerange.h
	oscinout.h
	oscinout.cpp
	playwithvoice.h
	playwithvoice.cpp
	mod_puredata.cpp
)

if (NOT ENABLE_WXWIDGETS)
	message (FATAL_ERROR "Currently requires wxWidgets")
endif(NOT ENABLE_WXWIDGETS)

find_package(wxWidgets COMPONENTS core base net REQUIRED)

add_library (mod_puredata SHARED ${mod_puredata_SRCS})
target_link_libraries(mod_puredata spcore)
target_link_libraries(mod_puredata oscpack)
target_link_libraries(mod_puredata ${wxWidgets_LIBRARIES})

INSTALL (TARGETS mod_puredata RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})
if (WIN32)
	if (MSVC)
		install_to_msvc_build_directory( "${EXECUTABLE_OUTPUT_PATH}" "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxbase28ud_vc_custom.dll")		
	endif(MSVC)
	install(FILES "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxbase28ud_net_vc_custom.dll" DESTINATION "${BINDIR}" CONFIGURATIONS Debug)
	install(FILES "${wxWidgets_ROOT_DIR}/lib/vc_dll/wxbase28u_net_vc_custom.dll" DESTINATION "${BINDIR}" CONFIGURATIONS Release RelWithDebInfo)
endif(WIN32)

=== src/mod_score_player/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(mod_score_player)

set(mod_score_player_SRCS
	mod_score_player.cpp
	scoreplayer.h
	scoreplayer.cpp
	instrselect.h
	instrselect.cpp
)

add_library (mod_score_player SHARED ${mod_score_player_SRCS})
target_link_libraries(mod_score_player spcore)
target_link_libraries(mod_score_player ${Boost_THREAD_LIBRARY})

INSTALL (TARGETS mod_score_player RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})

=== src/mod_sdl/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(mod_sdl)

set (SDL_BUILDING_LIBRARY ON)
find_package ( SDL REQUIRED )

set(mod_sdl_SRCS
	${CUSTOM_INCLUDE_PATH}/mod_sdl/sdlsurfacetype.h
	mod_sdl.cpp
)

set(mod_sdl_gui_SRCS
	config_gui.h
	config_gui.cpp
)

include_directories (${SDL_INCLUDE_DIR})

# Base library
add_library (mod_sdl SHARED ${mod_sdl_SRCS})
target_link_libraries(mod_sdl spcore)
target_link_libraries(mod_sdl ${SDL_LIBRARY})

# Base gui library
add_library (mod_sdl_gui SHARED ${mod_sdl_gui_SRCS})
target_link_libraries(mod_sdl_gui spcore)
target_link_libraries(mod_sdl_gui ${wxWidgets_LIBRARIES})

add_subdirectory(tests)

INSTALL (TARGETS mod_sdl RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})

IF (WIN32)
	FIND_PATH (SDL_RUNTIME_LIBS_DIR SDL.dll
		HINTS
		$ENV{SDLDIR}
		PATH_SUFFIXES lib64 lib
		PATHS)
	FILE (GLOB SDL_RUNTIME_LIBS ${SDL_RUNTIME_LIBS_DIR}/*.dll)
	
	INSTALL (PROGRAMS ${SDL_RUNTIME_LIBS} DESTINATION ${LIBRUNTIMEDIR})
ENDIF (WIN32)

=== src/mod_vision/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(mod_vision)

FIND_PACKAGE( OpenCV REQUIRED )
INCLUDE_DIRECTORIES (${OpenCV_INCLUDE_DIR})
INCLUDE_DIRECTORIES (..)

set(mod_vision_SRCS
	mod_vision.cpp	
	oftracker.h
	oftracker.cpp
)

add_library (mod_vision SHARED ${mod_vision_SRCS})
target_link_libraries(mod_vision creavision)
target_link_libraries(mod_vision spcore)

INSTALL (TARGETS mod_vision RUNTIME DESTINATION ${PLUGINDIR} LIBRARY DESTINATION ${LIBDIR})

=== debian/changelog ===
sitplus (1.0.1-3) unstable; urgency=low

  * debian/control: Build-Depends: libcv-dev (>= 2.3.1-7)
  * debian/rules:
    - Apply patch kindly provided by Nobuhiro Iwamatsu
      <iwamatsu@debian.org> (thanks)
      Closes: #653799
    - Add "-lopencv_core -lopencv_highgui" to linker flags because
      cmake seems to fail adding these

 -- Andreas Tille <tille@debian.org>  Mon, 09 Jan 2012 10:10:13 +0100

sitplus (1.0.1-2) unstable; urgency=low

  * debian/patches/as-needed.patch: Fix FTBFS with --as-needed linker option.
    (Thanks to Ilya Barygin <randomaction@ubuntu.com> for the patch)
    Closes: #647401
  * debian/control: Added myself to uploaders
  * Debhelper 8 (control+compat)
  * debian/copyright: Some DEP5 related reformating

 -- Andreas Tille <tille@debian.org>  Fri, 04 Nov 2011 09:24:12 +0100

sitplus (1.0.1-1) unstable; urgency=low

  * Initial release (Closes: #635597)
  * Changed license for graphics/pictures which enables dirstribution
    in Debian
  * doc_location_fix patch no longer needed: fixed in upstream.
  * Fixing patches descriptions.

 -- Luis Rivas Vañó <luinix@gmail.com>  Mon, 22 Aug 2011 14:20:38 +0200

sitplus (1.0.0-2) UNRELEASED; urgency=low

  * Minor changes in debian directory organization.
  * Added a manpage for sitplus package.
  * Changed the maintainer and added myself as an uploader.
  * Updated Vcs fields in control file.
  * Fixing copyright file: BY-NC-SA version from 2.5 to 3.0.
  * Added descriptions to quilt patches.
  * Added a new quilt patch for fixing spelling error in source code.
  * Removed templates from debian/rules

 -- Luis Rivas Vañó <luinix@gmail.com>  Wed, 17 Aug 2011 15:46:11 +0200

sitplus (1.0.0-1) UNRELEASED; urgency=low

  * First packaging effort

 -- Luis Rivas Vañó <luinix@gmail.com>  Wed, 27 Jul 2011 14:22:14 +0200

=== debian/control ===
Source: sitplus
Section: misc
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Luis Rivas Vañó <luinix@gmail.com>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 8), cmake, libpoco-dev, libboost-dev,
 libboost-program-options-dev, libboost-thread-dev, libboost-system-dev,
 wx2.8-headers, libwxbase2.8-dev, libbluetooth-dev, libconfig8-dev, libsdl1.2-dev,
 libcv-dev (>= 2.3.1-7), libcvaux-dev, libhighgui-dev, libv4l-dev, libportmidi-dev,
 libboost-filesystem-dev, asciidoc, libsdl-gfx1.2-dev, libsdl-image1.2-dev,
 libwxgtk2.8-dev
Standards-Version: 3.9.2
Homepage: http://sitplus.crea-si.com
Vcs-Git: git://git.debian.org/debian-med/sitplus.git
Vcs-Browser: http://git.debian.org/?p=debian-med/sitplus.git

Package: sitplus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, sitplus-data, pd-cyclone, pd-freeverb, pd-iemnet, puredata, pd-libdir, pd-list-abs
Description: Free software framework for ludic-therapeutic activities
 SITPLUS is a free software (GNU GPL) framework whose main goal is to provide
 ludic-therapeutic activities for people with disabilities. It offers new forms
 of interaction based on computer vision, voice and other peripherals to
 produce a result in the form of image and sound. Inspired by the cause and
 effect applications, SITPLUS provides a tool for continuous and remote
 interaction, attainable to the majority of people with cognitive, sensory and
 physical disabilities.

Package: sitplus-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sitplus
Description: Data files for Sitplus, a framework for ludic-therapeutic activities
 SITPLUS is a free software (GNU GPL) framework whose main goal is to provide
 ludic-therapeutic activities for people with disabilities. It offers new forms
 of interaction based on computer vision, voice and other peripherals to
 produce a result in the form of image and sound. Inspired by the cause and
 effect applications, SITPLUS provides a tool for continuous and remote
 interaction, attainable to the majority of people with cognitive, sensory and
 physical disabilities.
 .
 This package provides the data for sitplus.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules file for sitplus
# Author: Luis Rivas Vañó <luinix@gmail.com>
# License: GPL-3.0+

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DCMAKE_INSTALL_RPATH=/usr/lib/sitplus \
	    -DCMAKE_EXE_LINKER_FLAGS="-lboost_system -lopencv_core -lopencv_highgui" \
	    -DOpenCV_DIR=/usr/share/OpenCV/

override_dh_auto_install:
	dh_auto_install
	rm -f ${CURDIR}/debian/tmp/usr/share/sitplus/graphics/pictures/License.txt

%:
	dh $@
